;
;   16 
;
;   _0 = 1:1 (   )
;  _0 = 16 ,  1  = 1/16000000 = 0,0000000625 
;  ,     256    0,0000000625*256 = 0,000016 
;    = 1/0,000016 =  62500 
; 
;        -     
;     0  255.
;       0  100%
; 
;      
;    _1
;         ,   -     .
;   = 16/64=62500,  1   = 0,000016  
;      1   ( = 1/1=1  )
;      1  62500  ( 0xF424 )



.include 	"m32def.inc"		;  ATMega32


.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;   /  SREG
.def	Temp5=R21 			; 
.def	Temp6=R22			; 		
.def	Temp7=R23			; 		
.def	Temp8=R24
.def	Temp9=R25



;******************************************************************************
; ******
;******************************************************************************

.dseg					; 

Peremennaya: .byte 2			;  2   

Peremennaya2: .byte 2			;  2   


;******************************************************************************
; 
;******************************************************************************


.EQU Compare_1 =0xF424			;  = 62500 (   _1 )




;******************************************************************************
; ******
;******************************************************************************
;  
;******************************************************************************

.cseg	

		

.org 0					; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset
rjmp RESET				;  				



.org   OC1Aaddr				; Timer/Counter1 Compare Match A 
rjmp OCR1A_COMP				; (    _1 )



.org INT_VECTORS_SIZE			;   




;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    



	ldi Temp, low(RAMEND)		;  
	out SPL, Temp
	ldi Temp, high(RAMEND)
	out SPH, Temp




;******************************************************************************
;  
;******************************************************************************




	ldi Temp,0b00001000		;   "" (0-, 1-)
	out DDRB,Temp			; 
					 
		
			

	ldi Temp,0b00000000		;  _0   "B" 0b0000*000 (   )
	out PortB,Temp			; 




;******************************************************************************
;  
;******************************************************************************


;	RCALL	LCD_INIT		;  



;******************************************************************************
;  
;******************************************************************************
 
; "" 

	LDI Temp, 12			; XL=0 (0x00) (0b00000000)
	LDI Temp1, 0			; XL=0 (0x0C) (0b00001100)

	STS Peremennaya, Temp		;    "Peremennaya"   "Temp"
	STS Peremennaya+1, Temp1	; 



;******************************************************************************
;  
;******************************************************************************



; _0 ************************************************************************************************************
; fast pwm





	ldi Temp,(1<<COM01)|(0<<COM00)|(1<<wgm01)|(1<<wgm00)|(1<<cs00)	
	out TCCR0,Temp							
									
								;      0xFF
								; (   ,    )
								;    = CK 1:1  ( 16,  1   = 0,0000000625  )
								;   .



	LDI Temp,0xFF						;    
	OUT OCR0,Temp						; 


	ldi Temp,0						;   
	out TCNT0,Temp




; _1 ************************************************************************************************************
; normal mode (    )







;	ldi Temp,(0<<COM1A1)|(0<<COM1A0)|(0<<COM1B1)|(0<<COM1B0)|(0<<wgm11)|(0<<wgm10)
;	out TCCR1A,Temp	
								;    
								; 

								; COM1A1 /   OC1A
								; COM1A0 /   OC1A 
								; COM1B1 /   OC1B 
								; COM1B0 /   OC1B
								; FOC1A=0 /     OC1A // 
								; FOC1B=0 /     OC1B // 
								; WGM11=0 /  
								; WGM10=0 /  


	ldi Temp,(0<<WGM13)|(0<<WGM12)|(1<<cs12)|(0<<cs11)|(0<<cs10)		  
	out TCCR1B,Temp	
								;     = CK 1:256
								;   !!!

								; ICNC1=0 / 
								; ICES1=0 / 
								; WGM13=0 /  
								; WGM12=0 /   
								; CS12=0
								; CS11=1 / 
								; CS10=0 /   = 16/256=62500,  1   = 0,000016  




	LDI Temp,high(Compare_1)				;    
	OUT OCR1AH,Temp						; 
	LDI Temp,low(Compare_1)							
	OUT OCR1AL,Temp   




	ldi Temp,0						;   
	out TCNT1H,Temp
	out TCNT1L,Temp


	ldi Temp,(1<<OCIE1A)					;    
	out TIMSK,Temp





;*******************************************************************************************************************************
; 
;*******************************************************************************************************************************


	sei							;   
	


;*******************************************************************************************************************************
;  
;*******************************************************************************************************************************

Main:								;  



	Rjmp Main





;*******************************************************************************************************************************
;    _1
;*******************************************************************************************************************************

OCR1A_COMP:				; (    _1 )


;*******************************************************************************************************************************
;  SREG
;*******************************************************************************************************************************

	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4


;*******************************************************************************************************************************
;  
;*******************************************************************************************************************************




	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp


;*******************************************************************************************************************************

;  
; 
;   = 12 ( 0x000C ),    


					;   X  12 ( 0x000C )
	ldi XL, 0x0C			; 
	ldi XH, 0x00			; 


	lds YL, Peremennaya		;  (  )   "X"   "Peremennaya" 
	lds YH, Peremennaya+1		; 



	rcall compare_XY16		; ...

	breq Nachalo			;     X=Y (    )
	brcs Nachalo			;     X<Y (      )
	rjmp Prodolzhenie		;     X>Y (     )




Nachalo:


;  



	LDI Temp, 0			; XL=0 (0x00) (0b00000000)


	STS Peremennaya, Temp		;    "Peremennaya"   "Temp"
	STS Peremennaya+1, Temp		;

 




;    (GOLOS)     "Z"




	ldi ZL, Low (Golos*2)		;       Z
	ldi ZH, High (Golos*2)		; 

	STS Peremennaya2, ZL		;    "Peremennaya2" 
	STS Peremennaya2+1, ZH		;




Prodolzhenie:


	lds ZL, Peremennaya2		;  (  )   "Z"   "Peremennaya" 
	lds ZH, Peremennaya2+1		; 



	lpm				;   (  )          Z
	mov Temp, R0			; 


	OUT OCR0,Temp			;      



;     


	ldi Temp,  1			;  "1" ( 0x0001 )
	ldi Temp1, 0			; 


	add ZL, Temp			;       
	adc ZH, Temp1


	STS Peremennaya2, ZL		;    "Peremennaya2" 
	STS Peremennaya2+1, ZH		;


;     


	lds XL, Peremennaya		;  (  )   "X"   "Peremennaya" 
	lds XH, Peremennaya+1		; 


	ldi Temp, 1			;  1 ( 0x0001 ) ( 0b00000001 )
	ldi Temp1, 0

	add XL, Temp			; +1
	adc XH, Temp1			;


	STS Peremennaya, XL		;    "Peremennaya"   "X"
	STS Peremennaya+1, XH		; 







;***************************************************************************************************
;   *******************************************************************************


OCR1A_COMP_EXIT:				; 
   
	pop temp4				;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4



	RETI					;   


;*******************************************************************************************************************************
; 
;*******************************************************************************************************************************
;
; 
;
; Sample_rate 12



GOLOS:						; 

.db 0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF



;*******************************************************************************************************************************
;  
;*******************************************************************************************************************************



compare_XY16:

	cp XH,YH			;    
	breq xh_eq_yh			;    ,    xl  yl
					;   -   X<Y
					;   -   X>Y
	ret



xh_eq_yh:

	cp XL,YL			;    
					;  Z=1  X=Y
					;   -   X<Y
					;   -   X>Y

	ret                            

;*******************************************************************************************************************************
; 
;*******************************************************************************************************************************